//****************************************************************************
//	aisa37w.pas
//
//	aISA-P37
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/19
//
//****************************************************************************

unit aisa37w;

interface

uses
	Windows;

{ Errors }

const
	AISA37_SUCCESS							= 0;	 { ُȂ }
	AISA37_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA37_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA37_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA37_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA37_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA37_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA37_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA37_PORT_0	= 0;
	AISA37_PORT_1	= 1;


{ Miscellaneous }

const
	AISA37_MAX_SLOTS	= 16;	{ Maximum number of slots }


{ Device ID }

const
	AISA37_DEVICE_ID	= $00005021;

const
	AISA37_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA37_DLL_NAME = 'aisa37.dll';		{ DLL }

function Aisa37wDllOpen: Boolean;			{ DLL [h }
function Aisa37wDllClose: Boolean;		{ DLL A[h }


const
	AISA37_SLOT_AUTO = $ffff;

{ aISA-P37 DLL,Driver̃o[Wԍ擾 }
function Aisa37wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P37̎gp錾 }
function Aisa37wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P37̎gpJ }
function Aisa37wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA37_MAX_MEM	=	 9;
		AISA37_MAX_IO		= 20;
		AISA37_MAX_IRQ	=	 7;
		AISA37_MAX_DMA	=	 7;

type
		TAISA37RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA37_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA37_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA37_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA37_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA37_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA37_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA37_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA37_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA37_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA37RESOURCE = ^TAISA37RESOURCE;

{ \[X擾 }
function Aisa37wGetResource(wLogSlot: Word;  pResInfo: PAISA37RESOURCE): Boolean;

{ Cӂ̃|[gf[^ }
function Aisa37wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa37wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;


{ aISA-P37̃G[R[h }
function Aisa37wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa37GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa37Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa37Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa37GetResource = function(wLogSlot: WORD; res: PAISA37RESOURCE):	BOOL; stdcall;
	TAisa37InPort = function(wLogSlot: WORD; dwLogPort: DWORD; var lpbInValue: BYTE): BOOL; stdcall;
	TAisa37OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa37GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa37wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa37GetVersion: TAisa37GetVersion;
	pAisa37Create: TAisa37Create;
	pAisa37Close: TAisa37Close;
	pAisa37GetResource: TAisa37GetResource;
	pAisa37InPort: TAisa37InPort;
	pAisa37OutPort: TAisa37OutPort;
	pAisa37GetLastError: TAisa37GetLastError;


//****************************************************************************
// @\			aisa37.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa37wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA37_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa37wGetDllExportFunc = False then
  begin
       Aisa37wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa37.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa37wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P37 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drvo[Wԍi[
// ߂l 	True  				--- 
//		  		False 				--- s
//****************************************************************************
function Aisa37wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa37GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P37̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa37wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa37Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P37̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa37wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa37Close(wLogSlot);
end;


//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa37wGetResource(wLogSlot: Word;  pResInfo: PAISA37RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa37GetResource(wLogSlot, pResInfo);
end;


//****************************************************************************
// @\			Cӂ̃|[gf[^
// 			wLogSlot	--- ͂foCX
//					dwPort		--- ͂|[g
//					pbInValue --- ̓f[^i[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa37wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa37InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa37wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa37OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P37̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa37wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA37_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa37GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa37wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa37GetVersion ̃AhX擾
	pAisa37GetVersion := GetProcAddress(hDLL, 'Aisa37GetVersion');
	if @pAisa37GetVersion = nil then Exit;

	// Aisa37Create ̃AhX擾
	pAisa37Create := GetProcAddress(hDLL, 'Aisa37Create');
	if @pAisa37Create = nil then Exit;

	// Aisa37Close ̃AhX擾
	pAisa37Close := GetProcAddress(hDLL, 'Aisa37Close');
	if @pAisa37Close = nil then Exit;

	// Aisa37GetResource ̃AhX擾
	pAisa37GetResource := GetProcAddress(hDLL, 'Aisa37GetResource');
	if @pAisa37GetResource = nil then Exit;

	// Aisa37InPort ̃AhX擾
	pAisa37InPort := GetProcAddress(hDLL, 'Aisa37InPort');
	if @pAisa37InPort = nil then Exit;

	// Aisa37OutPort ̃AhX擾
	pAisa37OutPort := GetProcAddress(hDLL, 'Aisa37OutPort');
	if @pAisa37OutPort = nil then Exit;

	// Aisa37GetLastError ̃AhX擾
	pAisa37GetLastError := GetProcAddress(hDLL, 'Aisa37GetLastError');
	if @pAisa37GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

