Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa37w.bas
'*
'* aISA-P37
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/04/30
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA37_DLL_NAME = "aisa37.dll"  ' DLLt@C
Global Const AISA37_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa37.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa37wDllOpen() As Boolean

    Aisa37wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA37_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa37wGetDllExportFunc() = False Then
        Aisa37wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa37wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa37.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa37wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa37wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa37wDllClose = True
        Exit Function
    End If
    
    Aisa37wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-P37 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True          --- 
'*          False         --- s
'*****************************************************************************
Function Aisa37wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa37wGetVersion = 0
        Exit Function
    End If
    
    If Aisa37GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa37wGetVersion = True
    Else
        Aisa37wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P37̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa37wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa37wCreate = False
        Exit Function
    End If
    
    If Aisa37Create(pwLogSlot) <> 0 Then
        Aisa37wCreate = True
    Else
        Aisa37wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P37̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa37wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa37wClose = False
        Exit Function
    End If
    
    If Aisa37Close(wLogSlot) <> 0 Then
        Aisa37wClose = True
    Else
        Aisa37wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa37wGetResource(wLogSlot As Integer, pResInfo As AISA37RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa37wGetResource = False
        Exit Function
    End If
    
    If Aisa37GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa37wGetResource = True
    Else
        Aisa37wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gf[^
'*      wLogSlot  --- ͂foCX
'*          dwPort    --- ͂|[g
'*          pbInValue --- ̓f[^i[
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa37wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa37wInPort = False
        Exit Function
    End If
    
    If Aisa37InPort(wLogSlot, dwPort, pbInValue) <> 0 Then
        Aisa37wInPort = True
    Else
        Aisa37wInPort = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa37wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa37wOutPort = False
        Exit Function
    End If
    
    If Aisa37OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa37wOutPort = True
    Else
        Aisa37wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-P37̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa37wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa37wGetLastError = AISA37_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa37wGetLastError = Aisa37GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa37wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa37wGetDllExportFunc = False
    
    ' Aisa37GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa37Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa37Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37Close")
    If pFunc = 0 Then Exit Function

    ' Aisa37GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa37InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa37OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa37GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa37GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa37wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
